#ifndef CLAY_CLAY_CONTEXT_H
#define CLAY_CLAY_CONTEXT_H

#include "clay-property.h"
#include <stdbool.h>

typedef struct {
    const char * name;
    int tag;
    clay_property_type type;
} clay_property_desc_s, *clay_property_desc;
// TODO: properties should not keep track of the type and allow any type, or something?


void clay_ctx_register_layout(clay_ctx ctx, clay layout);
void clay_ctx_unregister_layout(clay_ctx ctx, clay layout);

int clay_ctx_register_property(clay_ctx ctx, const char * name, clay_property_type type);
void clay_ctx_unregister_property(clay_ctx ctx, int tag);
bool clay_ctx_has_property(clay_ctx ctx, const char *name);
clay_property_desc clay_ctx_get_property_desc(clay_ctx ctx, const char * name);

#endif //CLAY_CLAY_CONTEXT_H
