#ifndef CLAY_CLAY_LAYOUT_H
#define CLAY_CLAY_LAYOUT_H

#include "clay.h"
#include "clay-property.h"

typedef void (*init_fn)(clay);

typedef void (*cleanup_fn)(clay);
typedef void (*debug_fn)(clay);


struct layout_class {
    init_fn init;
    cleanup_fn cleanup;
    debug_fn debug;
};

struct clay_t {
    struct layout_class class;
    clay_property_set properties;
    clay_ctx ctx;
};

clay clay_create_layout(clay_ctx ctx, struct layout_class class);

void clay_destroy_layout(clay layout);

void clay_cleanup_layout(clay layout);

clay_property_value clay_get_prop(clay layout, const char *prop);

#endif //CLAY_CLAY_LAYOUT_H
